var mongoose = require('mongoose');

exports.params = {
	host: {
		type: 'input', 
		name: 'Host'
	},
	database: {
		type: 'input',
		name: 'Default database'
	},
	user: {
		type: 'input',
		name: 'Username'
	},
	pass: {
		type: 'input',
		name: 'Password'
	}
};


exports.plugin = function(router, params)
{
	
    var mongoUrl = process.env.MONGODB_URL;
	
	router.on({
		
		/**
		 */

		
		'push init': function()
		{
			console.ok('Starting up application database');
	
			var connectionString = '';    
			
		    if(!params.port) params.port = 27017;
			
			if(params.user && params.pass)
			{
				connectionString += params.user + ':' + params.pass + '@';
			}
			
			connectionString += (params.host || 'localhost') +  ':' + params.port + '/' + params.database;

			mongodb = mongoose.createConnection(mongoUrl || 'mongodb://' + connectionString);
			

			//push the database
			router.push('mongodb', mongodb);
			
			
			router.on({

				/**
				 */

				'pull mongodb': function()
				{
					return mongodb;
				}
			});
		}
	});
}